//+------------------------------------------------------------------+
//|                                                     Template.mq4 |
//|                                   Copyright 2016,                |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, "
#property link      ""
#property version   "1.00"
#property strict

#define MAGICMA  20160916

extern string Trades             = "  ";
extern double Lots               = 0.1;
extern int TakeProfit            = 20;
extern int StopLoss              = 20;
extern int TralLevel             = 20;
extern int Power_Slow            = 15;
extern bool UseTral              = true;

string Frames             = "    ";
int Main_TimeFrame        = 15; // 1-PERIOD_M1, 5-PERIOD_M5, 15-PERIOD_M15, 30-PERIOD_M30, 60-PERIOD_H1, 240-PERIOD_H4, 1440-PERIOD_D1, 10080-PERIOD_W1, 43200-PERIOD_MN1
int Slow_TimeFrame        = 60; // 1-PERIOD_M1, 5-PERIOD_M5, 15-PERIOD_M15, 30-PERIOD_M30, 60-PERIOD_H1, 240-PERIOD_H4, 1440-PERIOD_D1, 10080-PERIOD_W1, 43200-PERIOD_MN1

string FastMA="   EMA";
extern int ma0_period=5;

string SlowMA1="   EMA  ";
extern int ma1_slag=2;
int ma1_period=6;

int GAP_Level=20;   //    10 
int GAP_TimeOUT                  = 10;
int GAP_Timer                    = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//----
   if(Digits==5 || Digits==3)
     {
      TakeProfit  *=10;
      StopLoss    *=10;
      GAP_Level   *=10;
      TralLevel   *=10;
      Power_Slow  *=10;
     }
   ma1_period=ma0_period+ma1_slag;
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//----

//----
   return;
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
void OnTick()
  {
//----
   if(AccountEquity()<=MarketInfo(Symbol(),MODE_MARGINREQUIRED)*Lots)return; //    
   if(Bars<100 || IsTradeAllowed()==false) return;
   if(isNewBar()==false) return;   //      - 
   if(CountVsego()==0) CheckForOpen();
   else CheckForClose();
//----
   return;
  }
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
int CalculateCurrentOrders(string symbol)
  {
   int buys=0,sells=0;
   for(int i=0;i<OrdersTotal();i++)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==symbol && OrderMagicNumber()==MAGICMA)
        {
         if(OrderType()==OP_BUY)  buys++;
         if(OrderType()==OP_SELL) sells++;
        }
     }
   if(buys>0) return(buys);
   else       return(-sells);
  }
//+------------------------------------------------------------------+
void CheckForOpen()
  {
//if(isNewBar()==false) return;   //      - 

   int res;

   int gap=(int)(MathAbs(Open[0]-Close[1])/Point);
   if(gap>GAP_Level) GAP_Timer=GAP_TimeOUT;

   if(GAP_Timer>0)
     {
      GAP_Timer--;
      if(GAP_Timer > 0) return;
     }

   if(Signal_Sell())
     {
      res=OrderSend(Symbol(),OP_SELL,Lots,Bid,5,Bid+StopLoss*Point,Bid-TakeProfit*Point,"",MAGICMA,0,Red);
      return;
     }

   if(Signal_Buy())
     {
      res=OrderSend(Symbol(),OP_BUY,Lots,Ask,5,Ask-StopLoss*Point,Ask+TakeProfit*Point,"",MAGICMA,0,Blue);
      return;
     }
  }
//+------------------------------------------------------------------+
bool Signal_Buy()
  {
   double ma5_1 = iMA(NULL,0, ma0_period,0,MODE_EMA,PRICE_CLOSE,1);
   double ma5_2 = iMA(NULL,0, ma1_period,1,MODE_EMA,PRICE_CLOSE,1);
   if(ma5_1>ma5_2) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
bool Signal_Sell()
  {
   double ma5_1 = iMA(NULL,0, ma0_period,0,MODE_EMA,PRICE_CLOSE,1);
   double ma5_2 = iMA(NULL,0, ma1_period,1,MODE_EMA,PRICE_CLOSE,1);
   if(ma5_1<ma5_2) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
void CheckForClose()
  {
//double SL,TP;
//int profit;
//int temp1;
   bool res;
   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(UseTral)
           {
            if(Bid-OrderOpenPrice()>TralLevel*Point)
              {
               if(OrderStopLoss()<Bid-TralLevel*Point)
                 {
                  res=OrderModify(OrderTicket(),OrderOpenPrice(),Bid-TralLevel*Point,OrderTakeProfit(),0,Green);
                 }
              }
           }
         else //  
           {
            if(OrderOpenPrice()<Bid-15*Point && OrderOpenPrice()>OrderStopLoss())
              {
               res=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+5*Point,OrderTakeProfit(),0,Blue);
               if(res==false)
                 {
                  Print("Error Modify BUY. Open = ",OrderOpenPrice()," Stop = ",OrderOpenPrice()+2*Point,
                        " Bid = ",Bid," Ask = ",Ask);
                 }
              }
           }
        }
      if(OrderType()==OP_SELL)
        {
         if(UseTral)
           {
            if((OrderOpenPrice()-Ask)>TralLevel*Point)
              {
               if((OrderStopLoss()>(Ask+TralLevel*Point)))
                 {
                  res=OrderModify(OrderTicket(),OrderOpenPrice(),Ask+TralLevel*Point,OrderTakeProfit(),0,Red);
                 }
              }
           }
         else //  
           {
            if(OrderOpenPrice()>Ask+15*Point && OrderOpenPrice()<OrderStopLoss())
              {
               res=OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-5*Point,OrderTakeProfit(),0,Red);
               if(res==false)
                 {
                  Print("Error Modify SELL. Open = ",OrderOpenPrice()," Stop = ",OrderOpenPrice()-2*Point,
                        " Ask = ",Ask," Bid = ",Bid);
                 }
              }
           }
        }
     }
  }
//+------------------------------------------------------------------+
/*void CheckForClose()
  {
//if(isNewBar(Period()) == false)return;

   double SL,TP;
   int profit;

   for(int i=OrdersTotal()-1; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderMagicNumber()!=MAGICMA || OrderSymbol()!=Symbol()) continue;
      //---- check order type 
      if(OrderType()==OP_BUY)
        {
         if(Signal_Stop_Buy())
           {
            OrderClose(OrderTicket(),OrderLots(),Bid,3,White);
            CheckForOpen();
           }
         break;
        }
      if(OrderType()==OP_SELL)
        {
         if(Signal_Stop_Sell())
           {
            OrderClose(OrderTicket(),OrderLots(),Ask,3,White);
            CheckForOpen();
           }
         break;
        }
     }
  }*/
//+------------------------------------------------------------------+
bool Signal_Stop_Buy()
  {
   double ma5_1 = iMA(NULL,0, ma0_period,0,MODE_EMA,PRICE_CLOSE,1);
   double ma5_2 = iMA(NULL,0, ma1_period,1,MODE_EMA,PRICE_CLOSE,1);
   if(ma5_1<ma5_2) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
bool Signal_Stop_Sell()
  {
   double ma5_1 = iMA(NULL,0, ma0_period,0,MODE_EMA,PRICE_CLOSE,1);
   double ma5_2 = iMA(NULL,0, ma1_period,1,MODE_EMA,PRICE_CLOSE,1);
   if(ma5_1>ma5_2) return(true);
   return(false);
  }
//+------------------------------------------------------------------+
//|  true,       /  |
//+------------------------------------------------------------------+
bool isNewBar()
  {
//---         
   static datetime last_time=0;
//---  
   datetime lastbar_time=(datetime)(SeriesInfoInteger(Symbol(),Period(),SERIES_LASTBAR_DATE));

//---     
   if(last_time==0)
     {
      //---     
      last_time=lastbar_time;
      return(false);
     }

//---   
   if(last_time!=lastbar_time)
     {
      //---     true
      last_time=lastbar_time;
      return(true);
     }
//---     -    ,  false
   return(false);
  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
int CountSELL()
  {
   int count=0;
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderType()==OP_SELL)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
int CountBUY()
  {
   int count=0;
   int i;
   for(i=OrdersTotal()-1;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
        {
         if(OrderSymbol()==Symbol() && OrderMagicNumber()==MAGICMA && OrderType()==OP_BUY)
            count++;
        }
     }
   return(count);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountVsego()
  {
   int Vsego;
   Vsego=CountBUY()+CountSELL();

   return(Vsego);
  }
//+------------------------------------------------------------------+
